#include <stdio.h>
#include <ctype.h>

unsigned int offset, attr ;
char *str, data ;

#define  crt_putc(data,attr,row,col)  { offset = (row)*160 + (col)*2;\
         mem_putc(data,attr,offset); }
#define  crt_puts(str,attr,row,col)  { offset = (row)*160 + (col)*2;\
         mem_puts(str,attr,offset); }

extern clear_screen();
extern set_cursor();

box(left_up_row,left_up_col,right_down_row,right_down_col,label,type)
char *label ;
{
	int i, j, cv, ch ;
	cv = left_up_row ;
	ch = left_up_col ;

	if (type==1) crt_putc(218,0x07,cv,ch++);
	if (type==2) crt_putc(201,0x07,cv,ch++);
	for ( i = left_up_col+1; i < right_down_col; i++)
	{	if (type==1) crt_putc(196,0x07,cv,ch++) ;
		if (type==2) crt_putc(205,0x07,cv,ch++) ;
	}
	if (type==1) crt_putc(191,0x07,cv,ch++) ;
	if (type==2) crt_putc(187,0x07,cv,ch++) ;
	cv++ ;
	for ( j = left_up_row+1; j < right_down_row; j++)
	{
		if (type==1)
		{	crt_putc(179,0x07,cv,left_up_col) ;
                	crt_putc(179,0x07,cv++,right_down_col) ;
		}
		if (type==2)
		{	crt_putc(186,0x07,cv,left_up_col) ;
			crt_putc(186,0x07,cv++,right_down_col) ;
		}
	}
	cv = right_down_row ;
	ch = left_up_col ;
	if (type==1) crt_putc(192,0x07,cv,ch++) ;
	if (type==2) crt_putc(200,0x07,cv,ch++) ;
	for ( i = left_up_col+1; i < right_down_col; i++)
	{	if (type==1) crt_putc(196,0x07,cv,ch++) ;
		if (type==2) crt_putc(205,0x07,cv,ch++) ;
	}
	if (type==1) crt_putc(217,0x07,cv,ch++) ;
	if (type==2) crt_putc(188,0x07,cv,ch++) ;
	i = left_up_col+(right_down_col-left_up_col+1)/2-strlen(label)/2 ;
	crt_puts(label,0x0E,left_up_row,i) ;
}

int	ROWS[8] = {5,11,17,23,5,11,17,23};
int	COLS[8] = {5,5,5,5,45,45,45,45};

int	ROWI[16] = {2,2,2,2,8,8,8,8,14,14,14,14,20,20,20,20};
int	COLI[16] = {9,29,49,69,9,29,49,69,9,29,49,69,9,29,49,69};
int	ROWO[16] = {3,3,3,3,9,9,9,9,15,15,15,15,21,21,21,21};
int	COLO[16] = {9,29,49,69,9,29,49,69,9,29,49,69,9,29,49,69};

int	ROWB[16] = {5,5,5,5,11,11,11,11,17,17,17,17,23,23,23,23};
int	COLB[16] = {6,26,46,66,6,26,46,66,6,26,46,66,6,26,46,66};

int	ROWQ[16] = {4,4,4,4,10,10,10,10,16,16,16,16,22,22,22,22};
int	COLQ[16] = {6,26,46,66,6,26,46,66,6,26,46,66,6,26,46,66};
char	buffer[16];

boxi_put(box,val)
int	box;
unsigned long	val;
{
	sprintf(buffer,"%08lX",val);
	crt_puts(buffer,0x2F,ROWI[box],COLI[box]) ;
}

boxo_put(box,val)
int	box;
unsigned long	val;
{
	sprintf(buffer,"%08lX",val);
	crt_puts(buffer,0x1F,ROWO[box],COLO[box]) ;
}

box_putb(box,buf)
int	box;
char	*buf;
{
	crt_puts(buf,0x3F, ROWB[box], COLB[box]); 
}


box_putq(box,val)
int	box;
unsigned long val;
{
	sprintf(buffer,"%08lx",val);
	crt_puts(buffer,0x0F, ROWQ[box], COLQ[box]); 
}

/*box_puts(box,buf)
int	box;
char	*buf;
{
	crt_puts(buf,0x7F,ROWS[box],COLS[box]-2) ;
}
*/
/*extern char *TypeName[];*/

ShowForm(n)
int	n;
{
	char	buf[100];
	
	if ( !video_mode() ) {
		printf("This demo program only support 80X25 text mode.\n");
		exit(0);
	}
	clear_screen() ;
	set_cursor(30,0);	/* set cursor invisable */
    sprintf(buf, "*************************  PCIPORT CARD DEMO PROGRAM  *************************");
	crt_puts(buf, 0x4f, 0, 0);
	
       box( 1, 0, 6, 19, "PORT 01 (A)", 2);	
	crt_puts("INPUT:            ",0x2F,2,1); 
	crt_puts("OUTPUT:           ",0x1F,3,1); 
	crt_puts("BAUD:             ",0x3F,5,1); 
	
	box( 1, 20, 6, 39, "PORT 02 (B)", 2);	
	crt_puts("INPUT:            ",0x2F,2,21); 
	crt_puts("OUTPUT:           ",0x1F,3,21); 
	crt_puts("BAUD:             ",0x3F,5,21); 	

	box( 1, 40, 6, 59, "PORT 03 (C)", 2);	
	crt_puts("INPUT:            ",0x2F,2,41); 
	crt_puts("OUTPUT:           ",0x1F,3,41); 
	crt_puts("BAUD:             ",0x3F,5,41); 	

	box( 1, 60, 6, 79, "PORT 04 (D)", 2);	
	crt_puts("INPUT:            ",0x2F,2,61); 
	crt_puts("OUTPUT:           ",0x1F,3,61); 
	crt_puts("BAUD:             ",0x3F,5,61); 	

	box( 7, 0, 12, 19, "PORT 05 (E)", 2);	
	crt_puts("INPUT:            ",0x2F,8,1); 
	crt_puts("OUTPUT:           ",0x1F,9,1); 
	crt_puts("BAUD:             ",0x3F,11,1); 	

	box( 7, 20, 12, 39, "PORT 06 (F)", 2);	
	crt_puts("INPUT:            ",0x2F,8,21); 
	crt_puts("OUTPUT:           ",0x1F,9,21); 
	crt_puts("BAUD:             ",0x3F,11,21); 	 

	box( 7, 40, 12, 59, "PORT 07 (G)", 2);	
	crt_puts("INPUT:            ",0x2F,8,41); 
	crt_puts("OUTPUT:           ",0x1F,9,41); 
	crt_puts("BAUD:             ",0x3F,11,41); 	

	box( 7, 60, 12, 79, "PORT 08 (H)", 2);	
	crt_puts("INPUT:            ",0x2F,8,61); 
	crt_puts("OUTPUT:           ",0x1F,9,61); 
	crt_puts("BAUD:             ",0x3F,11,61); 	 

        box( 13, 0, 18, 19, "PORT 09 (I)", 2);	
	crt_puts("INPUT:            ",0x2F,14,1); 
	crt_puts("OUTPUT:           ",0x1F,15,1); 
	crt_puts("BAUD:             ",0x3F,17,1); 
	
	box( 13, 20, 18, 39, "PORT 10 (J)", 2);	
	crt_puts("INPUT:            ",0x2F,14,21); 
	crt_puts("OUTPUT:           ",0x1F,15,21); 
	crt_puts("BAUD:             ",0x3F,17,21); 	

	box( 13, 40, 18, 59, "PORT 11 (K)", 2);	
	crt_puts("INPUT:            ",0x2F,14,41); 
	crt_puts("OUTPUT:           ",0x1F,15,41); 
	crt_puts("BAUD:             ",0x3F,17,41); 	

	box( 13, 60, 18, 79, "PORT 12 (L)", 2);	
	crt_puts("INPUT:            ",0x2F,14,61); 
	crt_puts("OUTPUT:           ",0x1F,15,61); 
	crt_puts("BAUD:             ",0x3F,17,61); 	

	box( 19, 0, 24, 19, "PORT 13 (M)", 2);	
	crt_puts("INPUT:            ",0x2F,20,1); 
	crt_puts("OUTPUT:           ",0x1F,21,1); 
	crt_puts("BAUD:             ",0x3F,23,1); 	

	box( 19, 20, 24, 39, "PORT 14 (N)", 2);	
	crt_puts("INPUT:            ",0x2F,20,21); 
	crt_puts("OUTPUT:           ",0x1F,21,21); 
	crt_puts("BAUD:             ",0x3F,23,21); 	 

	box( 19, 40, 24, 59, "PORT 15 (O)", 2);	
	crt_puts("INPUT:            ",0x2F,20,41); 
	crt_puts("OUTPUT:           ",0x1F,21,41); 
	crt_puts("BAUD:             ",0x3F,23,41); 	

	box( 19, 60, 24, 79, "PORT 16 (P)", 2);	
	crt_puts("INPUT:            ",0x2F,20,61); 
	crt_puts("OUTPUT:           ",0x1F,21,61); 
	crt_puts("BAUD:             ",0x3F,23,61); 	
	

/* crt_puts(" A=Carrier O=Open M=Modem C=CTS R=RX D=DCD T=TX S=DSR B=Busy P=Paper L=Online ",0x4F, 24, 1);*/	set_cursor(0,0);	/* set cursor invisiable */
}

